function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/*
 * SPDX-License-Identifier: Apache-2.0
 *
 * The OpenSearch Contributors require contributions made to
 * this file be licensed under the Apache-2.0 license or a
 * compatible open source license.
 *
 * Any modifications Copyright OpenSearch Contributors. See
 * GitHub history for details.
 */

/*
 * Licensed to Elasticsearch B.V. under one or more contributor
 * license agreements. See the NOTICE file distributed with
 * this work for additional information regarding copyright
 * ownership. Elasticsearch B.V. licenses this file to you under
 * the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import React from 'react';
import PropTypes from 'prop-types';
import _ from 'lodash';
import { KuiTableRow, KuiTableRowCell, KuiTableRowCheckBoxCell } from '../';
import { LEFT_ALIGNMENT, RIGHT_ALIGNMENT } from '../../../services';
export class KuiListingTableRow extends React.PureComponent {
  constructor() {
    super(...arguments);
    _defineProperty(this, "onSelectionChanged", () => {
      this.props.onSelectionChanged(this.props.row.id);
    });
  }
  renderCells() {
    return this.props.row.cells.map((cell, index) => {
      let {
        content,
        ...props
      } = cell;
      if ( /*#__PURE__*/React.isValidElement(cell) || !_.isObject(cell)) {
        props = [];
        content = cell;
      }
      return /*#__PURE__*/React.createElement(KuiTableRowCell, _extends({
        key: index
      }, props), content);
    });
  }
  render() {
    const {
      enableSelection,
      isSelected
    } = this.props;
    return /*#__PURE__*/React.createElement(KuiTableRow, null, enableSelection && /*#__PURE__*/React.createElement(KuiTableRowCheckBoxCell, {
      isChecked: isSelected,
      onChange: this.onSelectionChanged
    }), this.renderCells());
  }
}
KuiListingTableRow.propTypes = {
  row: PropTypes.shape({
    id: PropTypes.string,
    cells: PropTypes.arrayOf(PropTypes.oneOfType([PropTypes.node, PropTypes.shape({
      content: PropTypes.node,
      align: PropTypes.oneOf([LEFT_ALIGNMENT, RIGHT_ALIGNMENT])
    })]))
  }).isRequired,
  enableSelection: PropTypes.bool,
  onSelectionChanged: PropTypes.func.isRequired,
  isSelected: PropTypes.bool
};
KuiListingTableRow.defaultProps = {
  enableSelection: true
};
